/*
 *  Copyright (c) 2011 The WebRTC project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a BSD-style license
 *  that can be found in the LICENSE file in the root of the source
 *  tree. An additional intellectual property rights grant can be found
 *  in the file PATENTS.  All contributing project authors may
 *  be found in the AUTHORS file in the root of the source tree.
 */

/******************************************************************

 iLBC Speech Coder ANSI-C Source Code

 WebRtcIlbcfix_InterpolateSamples.h

******************************************************************/

#ifndef WEBRTC_MODULES_AUDIO_CODING_CODECS_ILBC_MAIN_SOURCE_INTERPOLATE_SAMPLES_H_
#define WEBRTC_MODULES_AUDIO_CODING_CODECS_ILBC_MAIN_SOURCE_INTERPOLATE_SAMPLES_H_

#include "defines.h"

/*----------------------------------------------------------------*
 *  Construct the interpolated samples for the Augmented CB
 *---------------------------------------------------------------*/

void WebRtcIlbcfix_InterpolateSamples(
    WebRtc_Word16 *interpSamples, /* (o) The interpolated samples */
    WebRtc_Word16 *CBmem,   /* (i) The CB memory */
    WebRtc_Word16 lMem    /* (i) Length of the CB memory */
                                      );

#endif
